/* Sets normal, position, color per vertex */
uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform mat4 uNormalMatrix;
uniform vec3 uColor;

attribute vec3 aPosition;
attribute vec3 aNormal;

varying vec4 vPosition;
varying vec3 vNormal;
varying vec3 vColor;

void main() { 
    vPosition = uModelMatrix * vec4(aPosition, 1.0);
    vec4 Normal = vec4(aNormal, 1.0);
    vNormal = normalize((uNormalMatrix * Normal).xyz);
    
    vColor = uColor; // No per-vertex colors
  
    gl_Position = uProjMatrix * (uViewMatrix * vPosition);
}
