/*
 * CameraHelper.h
 *
 *  Created on: Nov 14, 2012
 *      Author: Karl
 */

#ifndef CAMERAHELPER_H_
#define CAMERAHELPER_H_

#include "glm/glm.hpp"
#include "glm/gtx/transform.hpp"
#include <algorithm>

using glm::vec3;

#define PI 3.14159

#define MAX_PITCH (80.0 / 180.0 * PI)
#define MIN_PITCH (-80.0 / 180.0 * PI)

#define START_YAW (PI / 2.0)
#define YAW_OFF (PI / 2.0)

class CameraHelper {
public:

    vec3 offset;
    double yaw;
    double pitch;

    CameraHelper();
    virtual ~CameraHelper();

    void reset();
    glm::vec3 getRelativeLookPoint();
    glm::vec3 getEye();
    glm::vec3 getCenter();

    void addYaw(double x);
    void addPitch(double y);
    void move(double move);
    void strafe(double strafe);
    void fly(double fly);
};

#endif /* CAMERAHELPER_H_ */
