/*
 * PhysicsEngine.h
 *
 *  Created on: Nov 20, 2012
 *      Author: Karl
 */

#ifndef PHYSICSENGINE_H_
#define PHYSICSENGINE_H_

#include "ModelHelper.h"

// m / s / ms
#define GRAVITY (-4 * MILLIS_TO_S)
#define FRICTION 1.1
#define NOISE_MIN 0.001
#define NOISE_MAX 0.005

#define DEG_TO_RAD 3.141593 * 180.0
#define COLLISION_RES 1

class PhysicsEngine {
public:
    std::vector<ModelHelper> &models;
    struct glHandles &h;
    vec3 gravity;

    PhysicsEngine(std::vector<ModelHelper> &scene, struct glHandles handles) :
        models(scene), h(handles) {
  	gravity = vec3(0, GRAVITY, 0);
    }
    ~PhysicsEngine();

    // len in milliseconds
    void tick(int millis);
};

#endif /* PHYSICSENGINE_H_ */
